package Controller;

import HibernateEntities.ModeratorsEntity;
import ServiceEntites.AddInfEnt;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.SessionAttributes;
import org.springframework.web.servlet.ModelAndView;

import static DAOImplement.AdminDao.updateAdmin;

/**
 * Created by kinetik on 05.03.17.
 */
@Controller
@SessionAttributes("Admin")
public class AdminMovController {

    @RequestMapping(value = "/PCabinAdminControl")
    public ModelAndView adminInNextViewChecker(@ModelAttribute("Admin") ModeratorsEntity admin) {
        ModelAndView adminFirstIn = new ModelAndView("inViews/firstInViews/adminFirstIn");
        adminFirstIn.addObject("Admin", admin);
        try {
            if (admin == null) {
                return new ModelAndView("otherViews/accessDeniedView");
            }
            if (admin.getModFirstIn() == null || admin.getModFirstIn() == 0) {
                admin.setModFirstIn(1);
                updateAdmin(admin);
                adminFirstIn.addObject("addInf", new AddInfEnt());
                return adminFirstIn;
            }
            return new ModelAndView("redirect:/PCabinAdmin");
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/PCabinAdmin")
    public ModelAndView adminPersonalCabinetGenerator(@ModelAttribute("Admin") ModeratorsEntity admin) {
        try {
            ModelAndView adminPersCabinet = new ModelAndView("inViews/persCabViews/adminPersCab");
            return adminPersCabinet;
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/PAdminChangeInfo")
    public ModelAndView adminChangeInfoData(@ModelAttribute("Admin") ModeratorsEntity admin) {
        try {
            ModelAndView adminChData = new ModelAndView("inViews/persCabViews/adminChangeInfo");
            adminChData.addObject("addInf", new AddInfEnt());
            return adminChData;
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/addInformAdmin")
    public ModelAndView updateClientInformation(@ModelAttribute("Admin") ModeratorsEntity admin,
                                                @ModelAttribute("addInf") AddInfEnt addInf) {
        try {
            admin.setModBirthdate(addInf.getBirthdate().trim());
            admin.setModEmail(addInf.getE_mail().trim());
            admin.setModHometown(addInf.getHometown().trim());
            admin.setModPhone(addInf.getPhone_number().trim());
            updateAdmin(admin);
            return new ModelAndView("redirect:/PCabinAdmin");
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }
}
