package Controller;

import HibernateEntities.ClientsEntity;
import HibernateEntities.ProjectsEntity;
import ServiceEntites.AddInfEnt;
import ServiceEntites.SelectProject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.enterprise.inject.Model;

import java.util.ArrayList;
import java.util.List;

import static DAOImplement.ClientsDao.getClientProject;
import static DAOImplement.ClientsDao.updateClient;

/**
 * Created by kinetik on 05.03.17.
 */
@Controller
@SessionAttributes("Client")
public class ClientMovController {

    @RequestMapping(value = "/PCabinClientControl")
    public ModelAndView clientInNextViewChecker(@ModelAttribute("Client") ClientsEntity client) {
        ModelAndView clientFirstIn = new ModelAndView("inViews/firstInViews/clientFirstIn");
        clientFirstIn.addObject("Client", client);
        try {
            if (client == null) {
                return new ModelAndView("otherViews/accessDeniedView");
            }
            if (client.getClFirstIn() == null || client.getClFirstIn() == 0) {
                client.setClFirstIn(1);
                updateClient(client);
                clientFirstIn.addObject("addInf", new AddInfEnt());
                return clientFirstIn;
            }
            return new ModelAndView("redirect:/PCabinClient");
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/PCabinClient")
    public ModelAndView clientPersonalCabinetGenerator(@ModelAttribute("Client") ClientsEntity client) {
        try {
            ModelAndView clientPersCabinet = new ModelAndView("inViews/persCabViews/clientPersCab");
            clientPersCabinet.addObject("projectList", getClientProject(client));
            return clientPersCabinet;
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/PClientChangeInfo")
    public ModelAndView adminChangeInfoData(@ModelAttribute("Client") ClientsEntity client) {
        try {
            ModelAndView clientChData = new ModelAndView("inViews/persCabViews/clientChangeInfo");
            clientChData.addObject("addInf", new AddInfEnt());
            return clientChData;
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/addInformClient")
    public ModelAndView updateClientInformation(@ModelAttribute("Client") ClientsEntity client,
                                                @ModelAttribute("addInf") AddInfEnt addInf) {
        try {
            client.setClBirthdate(addInf.getBirthdate().trim());
            client.setClCompany(addInf.getCompany().trim());
            client.setClEmail(addInf.getE_mail().trim());
            client.setClHometown(addInf.getHometown().trim());
            client.setClPos(addInf.getPosition().trim());
            client.setClPhone(addInf.getPhone_number().trim());
            updateClient(client);
            return new ModelAndView("redirect:/PCabinClient");
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }
}