package DAOImplement;

import HibernateEntities.ModeratorsEntity;
import org.hibernate.Session;
import org.hibernate.query.Query;

import javax.jws.WebParam;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static HibernateUtil.HibernateUtil.getSession;

/**
 * Created by Кинетик on 31.12.2016.
 */
public class AdminDao {
    public static HashMap<String, ModeratorsEntity> getAdminMap(){
        Session session = getSession();
        Query query = session.createQuery("FROM ModeratorsEntity ");
        List<ModeratorsEntity> res = query.list();
        HashMap<String, ModeratorsEntity> adminsDict = new HashMap<>();
        for(ModeratorsEntity ad: res){
            adminsDict.put(ad.getModFamily()+" "+ad.getModFirstName()+" "+ad.getModSecName(),ad);
        }
        session.close();
        return adminsDict;
    }
    public static ArrayList<String> getAdminList(){
        Session session = getSession();
        Query query = session.createQuery("FROM ModeratorsEntity ");
        List<ModeratorsEntity> res = query.list();
        ArrayList<String> adminsList = new ArrayList<>();
        for(ModeratorsEntity ad: res){
            adminsList.add(ad.getModFamily()+" "+ad.getModFirstName()+" "+ad.getModSecName());
        }
        session.close();
        return adminsList;
    }
    public static void createNewAdmin(ModeratorsEntity admin) {
        Session session = getSession();
        Query query = session.createQuery("select max(modId) from ModeratorsEntity ");
        Integer res = (Integer) query.uniqueResult();
        admin.setModId(res+1);
        session.beginTransaction();
        session.save(admin);
        session.getTransaction().commit();
        session.close();
    }
    public static void updateAdmin (ModeratorsEntity admin) {
        Session session = getSession();
        session.beginTransaction();
        session.update(admin);
        session.getTransaction().commit();
        session.close();
    }
    public static boolean checkIsAdmin(ModeratorsEntity admin){
        Session session = getSession();
        Query query = session.createQuery("FROM ModeratorsEntity WHERE modFamily = :Family and modFirstName = :Name and modSecName = :SecondName");
        query.setParameter("Family", admin.getModFamily());
        query.setParameter("Name", admin.getModFirstName());
        query.setParameter("SecondName", admin.getModSecName());
        List<ModeratorsEntity> res = query.list();
        if(res.size()==0){
            return false;
        }
        return true;
    }
}
